***NLPHHtimer*************************************************************************
***zyklischer Timer zum Starten beliebiger Anwendungen********************************
***Nationalpark Hunsrück-Hochwald, Rainer M. Kreten, Oktober 2020*********************
*** erstellt in Harbour Minigui 3.4.4 http://harbour-project.org/ ********************
**************************************************************************************

#include <hmg.ch>
#include "hbthread.ch"
FUNCTION Main
set century on
set date GERMAN
set language to german
set codepage to german
*** Variablenini***
public aThread := { NIL, NIL }
public mstunden := 0
public mminuten := 0
public msekunden:= 0
public mcountdown := 0
public mendlos := .F.
public mpfad := getcurrentfolder() + '\'
public mdatei := 'noch keine Datei ausgesucht'
fini() // Einlesen der gespeicherten Werte

IF !hb_mtvm()
   MSGSTOP("Keine Unterstützung für Multi-threading")
   QUIT
ENDIF

DEFINE WINDOW Form_1 AT 301 , 503 WIDTH 550 HEIGHT 350 Title 'NLPHH - Timer 1.0 vom Oktober 2020' MAIN

@ 25,300 IMAGE Image_1 PICTURE 'timersymbol.jpg' WIDTH 250 HEIGHT 150

@ 25,20 Label Label_1 VALUE 'Stunden'
@25,150 Spinner Spinner_1 range 0,23  value mstunden width 100  on change mstunden := this.value  increment 1

@ 55,20 Label Label_2 VALUE 'Minuten'
@ 55,150 Spinner Spinner_2 range 0,59  value mminuten width 100  on change mminuten := this.value  increment 1

@ 85,20 Label Label_3 VALUE 'Sekunden'
@85,150 Spinner Spinner_3 range 0,59  value msekunden width 100  on change msekunden := this.value increment 1

@ 115,150 CHECKBOX Checkbox_1 Caption "Endlosschleife" Width 100 Value mendlos on change mendlos := this.value

@145,20 BUTTON BUTTON_1 CAPTION "Dateiauswahl" WIDTH 100 HEIGHT 28 ACTION fdateiauswahl()
@185,20 BUTTON BUTTON_2 CAPTION "Start"WIDTH 100 HEIGHT 28 ACTION ( aThread[ 1 ] := hb_threadStart( HB_THREAD_INHERIT_PUBLIC , @ftimer() ) ) // Start Hintergrundthread
@185,150 BUTTON BUTTON_3 CAPTION "Stopp" WIDTH 100 HEIGHT 28  ACTION fstoppalles()

@ 235,20 Label Label_5 VALUE 'Countdown'
@ 225,150 PROGRESSBAR Progress_1 RANGE 1,100 Width 350 Height 28
@ 270,20 Label Label_4 Width 500 HEIGHT 28 Value mdatei
    
END WINDOW

Form_1.Center
Form_1.Activate

Return
*** Ende des Hauptprogrammes ***
*** Funktionen ******************************************************************************************************
function ftimer  // eigentliche Timerfunktion, läuft als Hintergrund-Thread
do while .not. file(mdatei) // Angabe einer ausführbaren Datei erzwingen
   fdateiauswahl()
enddo
fspeichern() // Speichern der Variablen in ini-Datei
Form_1.button_1.enabled := .F. // nicht mehrfach starten
Form_1.button_2.enabled := .F.
msekundengesamt = (mstunden * 3600) + (mminuten * 60) + msekunden
mprozent = 0
mstartTime = time()
mewig := .T.
do while mewig
   do while secs(elaptime(mstarttime,time())) <= msekundengesamt
            mcountdown = msekundengesamt - secs(elaptime(mstarttime,time()))
            Form_1.Label_5.Value := str(mcountdown,6,0)
            mprozent = round(100 - ((mcountdown / msekundengesamt) * 100),0)
		    Form_1.progress_1.value := mprozent 
            millisec(1000)
   enddo
   Form_1.Label_5.Value := 0
   Form_1.progress_1.value := 100
   faction()
   if mendlos = .F.
	  Form_1.button_1.enabled := .T.
      Form_1.button_2.enabled := .T.
	  fstoppalles()
      exit
   endif
   mstartTime = time()
enddo

return
****************************************************************************************************************
FUNCTION fdateiauswahl() // Auswahl der auszuführenden Datei
mdatei = getfile({ {'alle Dateien','*.*'} },'zu startende Datei',mpfad)
Form_1.Label_4.value := mdatei
return
****************************************************************************************************************
FUNCTION fstoppalles  // beendet alle Hintergrundthreads und reaktiviert die Bedienelemente
LOCAL i
   FOR i := 1 TO HMG_LEN( aThread ) 
      IF aThread[ i ] <> NIL
         hb_threadDetach( aThread[ i ] )   // close thread handle
         hb_threadQuitRequest( aThread[ i ] )   // terminate thread
         aThread[ i ] := NIL
      ENDIF
   NEXT
   Form_1.progress_1.value := 0
   Form_1.label_5.value := "Countdown"

   Form_1.button_1.enabled := .T.
   Form_1.button_2.enabled := .T.
Return Nil
*****************************************************************************************************************
function fspeichern // speichert die eingegebenen Werte in eine Textdatei, die beim nächsten Programmaufruf eingelesen wird
mspeicherstring = alltrim(str(mstunden,2,0)) + ';' + alltrim(str(mminuten,2,0)) + ';' + alltrim(str(msekunden,2,0)) + ';' + mdatei + ';'
if mendlos = .T.
   mspeicherstring = mspeicherstring + 'ja'
else
   mspeicherstring = mspeicherstring + 'nein'
endif
strfile(mspeicherstring,mpfad + 'NLPHHtimer.ini')
return
******************************************************************************************************************
function fini  // liest die ini-Datei ein 
mspeicherstring := ''
if file(mpfad + 'NLPHHtimer.ini')
   mspeicherstring = filestr(mpfad + 'NLPHHtimer.ini')
   mstunden  = val(token(mspeicherstring,';',1))
   mminuten  = val(token(mspeicherstring,';',2))
   msekunden = val(token(mspeicherstring,';',3))
   mdatei    = (token(mspeicherstring,';',4))
   if token(mspeicherstring,';',5) = 'ja'
      mendlos = .T.
   else
      mendlos = .F.
   endif
endif
return
********************************************************************************************************************
function faction  // und ACTION please
Execute file mdatei
return
********************************************************************   
   
   

